//===================================================================
// Apci8308w.pas - wrapper for Delphi 
//-------------------------------------------------------------------
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
unit Apci8308w;

interface

uses
  Windows, SysUtils;

const
	APCI8308_SUCCESS							=0;
	APCI8308_ERR_SYSTEM						=1;
	APCI8308_ERR_NO_DEVICE				=2;
	APCI8308_ERR_IN_USE						=3;
	APCI8308_ERR_INVALID_SLOT			=4;
	APCI8308_ERR_RESOURCE					=5;
	APCI8308_ERR_INVALID_ARGUMENT	=6;
	APCI8308_ERR_BUSY							=10;
	APCI8308_ERR_NO_ACTIVE				=11;
	APCI8308_ERR_NOT_ENOUGH_MEM		=12;
	APCI8308_ERR_INVALID_CH				=13;
	APCI8308_ERR_TIMEOUT					=14;
	APCI8308_ERR_NO_DATA					=15;
	APCI8308_ERR_BUFFER_OVER			=16;
	APCI8308_ERR_INVALID_PARAM		=17;
	APCI8308_ERR_WRAPDLL					=$FFFF;

	APCI8308_SLOT_AUTO						=$FFFF;
	APCI8308_MAX_SLOTS						=16;
	APCI8308_MAX_CH								=4;
	APCI8308_DLL_NAME							='Apci8308.dll';

	BIT0													=$01;
	BIT1													=$02;
	BIT2													=$04;
	BIT3													=$08;
	BIT4													=$10;
	BIT5													=$20;
	BIT6													=$40;
	BIT7													=$80;

	APCI8308_SIO_CH1							=0;
	APCI8308_SIO_CH2							=1;
	APCI8308_SIO_CH3							=2;
	APCI8308_SIO_CH4							=3;
	APCI8308_SIO_CH5							=4;
	APCI8308_SIO_CH6							=5;
	APCI8308_SIO_CH7							=6;
	APCI8308_SIO_CH8							=7;

	APCI8308_SIO_CB8							=(BIT0 or BIT1);
	APCI8308_SIO_CB7							=BIT1;
	APCI8308_SIO_CB6							=BIT0;

	APCI8308_SIO_PNONE						=0;
	APCI8308_SIO_PODD							=BIT3;
	APCI8308_SIO_PEVEN						=(BIT3 or BIT4);

	APCI8308_SIO_S1								=0;
	APCI8308_SIO_S2								=BIT2;

	APCI8308_SIO_BPS115200				=$0001;
	APCI8308_SIO_BPS57600					=$0002;
	APCI8308_SIO_BPS38400					=$0003;
	APCI8308_SIO_BPS19200					=$0006;
	APCI8308_SIO_BPS9600					=$000c;
	APCI8308_SIO_BPS4800					=$0018;
	APCI8308_SIO_BPS2400					=$0030;
	APCI8308_SIO_BPS1200					=$0060;
	APCI8308_SIO_BPS600						=$00c0;
	APCI8308_SIO_BPS300						=$0180;
	APCI8308_SIO_BPS150						=$0300;
	APCI8308_SIO_BPS110						=$0417;

	APCI8308_MAX_MEM							=9;
	APCI8308_MAX_IO								=20;
	APCI8308_MAX_IRQ							=7;
	APCI8308_MAX_DMA							=7;


type

	TAPCI8308_RESOURCE = record
		dwNumMemWindows:																	DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI8308_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI8308_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI8308_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																			DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI8308_MAX_IO]  of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI8308_MAX_IO]	of	DWORD;	// I/O߰Ē
		dwNumIRQs:																				DWORD;	// IRQ
		dwIRQRegisters: array [1 .. APCI8308_MAX_IRQ] of	DWORD;	// IRQؽ
		dwIRQAttrib:		array [1 .. APCI8308_MAX_IRQ] of	DWORD;	// IRQؽ
		dwNumDMAs:																				DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI8308_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI8308_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] 						 		of	DWORD;	// \(gp)
	end;
	PAPCI8308R = ^TAPCI8308_RESOURCE;

	TSIOMODE = record
		Baud:			WORD;
		WordSize:	BYTE;
		Parity:		BYTE;
		StopBits:	BYTE;
	end;
	PSIOMODE = ^TSIOMODE;

	TSIOSTATUS = record
		RxSize:		WORD;
	end;
	PSIOSTATUS = ^TSIOSTATUS;

// function
	function Apci8308wDllOpen: Boolean;
	function Apci8308wDllClose: Boolean;
	function Apci8308wGetVersion( var pdwDllVer:DWORD; var pdwDrvVer:DWORD ):Boolean;
	function Apci8308wCreate( var pwLogSlot:WORD ):Boolean;
	function Apci8308wClose( wLogSlot:WORD ):Boolean;
	function Apci8308wGetResource( wLogSlot:WORD; pRes:PAPCI8308R ):Boolean;
	function Apci8308wGetSwitchValue( wLogSlot:WORD; var pdwSwitchValue:DWORD ):Boolean;
	function Apci8308wGetLastError( wLogSlot:WORD ):DWORD;
	function Apci8308wSioStart( wLogSlot:WORD; wCh:WORD; pMode:PSIOMODE ):Boolean;
	function Apci8308wSioGetStatus( wLogSlot:WORD; wCh:WORD; pStatus:PSIOSTATUS ):Boolean;
	function Apci8308wSioRead( wLogSlot:WORD; wCh:WORD; var pbData:array of BYTE; dwDataSize:DWORD ):Boolean;
	function Apci8308wSioWrite( wLogSlot:WORD; wCh:WORD; var pbData:array of BYTE; dwDataSize:DWORD ):Boolean;
	function Apci8308wSioReset( wLogSlot:WORD; wCh:WORD ):Boolean;
	function Apci8308wSioStop( wLogSlot:WORD; wCh:WORD ):Boolean;

implementation

{$J+}	// ^t萔̕ύX\߲׎w

const
	hDLL: THandle = 0;
type
	TApci8308GetVersion 		= function ( var pdwDllVer:DWORD; var pdwDrvVer:DWORD ):Boolean; stdcall;
	TApci8308Create 				= function ( var pwLogSlot:WORD ):Boolean; stdcall;
	TApci8308Close 					= function ( wLogSlot:WORD ):Boolean; stdcall;
	TApci8308GetResource 		= function ( wLogSlot:WORD; pRes:PAPCI8308R ):Boolean; stdcall;
	TApci8308GetSwitchValue = function ( wLogSlot:WORD; var pdwSwitchValue:DWORD ):Boolean; stdcall;
	TApci8308GetLastError 	= function ( wLogSlot:WORD ):DWORD; stdcall;
	TApci8308SioStart 			= function ( wLogSlot:WORD; wCh:WORD; pMode:PSIOMODE ):Boolean; stdcall;
	TApci8308SioGetStatus 	= function ( wLogSlot:WORD; wCh:WORD; pStatus:PSIOSTATUS ):Boolean; stdcall;
	TApci8308SioRead 				= function ( wLogSlot:WORD; wCh:WORD; pbData:PCHAR; dwDataSize:DWORD ):Boolean; stdcall;
	TApci8308SioWrite 			= function ( wLogSlot:WORD; wCh:WORD; pbData:PCHAR; dwDataSize:DWORD ):Boolean; stdcall;
	TApci8308SioReset 			= function ( wLogSlot:WORD; wCh:WORD ):Boolean; stdcall;
	TApci8308SioStop 				= function ( wLogSlot:WORD; wCh:WORD ):Boolean; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci8308GetVersion			:TApci8308GetVersion;
	pApci8308Create					:TApci8308Create;
	pApci8308Close					:TApci8308Close;
	pApci8308GetResource		:TApci8308GetResource;
	pApci8308GetSwitchValue	:TApci8308GetSwitchValue;
	pApci8308GetLastError		:TApci8308GetLastError;
	pApci8308SioStart				:TApci8308SioStart;
	pApci8308SioGetStatus		:TApci8308SioGetStatus;
	pApci8308SioRead				:TApci8308SioRead;
	pApci8308SioWrite				:TApci8308SioWrite;
	pApci8308SioReset				:TApci8308SioReset;
	pApci8308SioStop				:TApci8308SioStop;

	function _Apci8308wGetDllExportFunc: Boolean; forward;

{$J-}

//===================================================================
//   	DLL۰(۰ގʹװƂ)
//   	
// ߂l  True
//				s False
//===================================================================
function Apci8308wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
		hDLL:=LoadLibrary(APCI8308_DLL_NAME);
		if hDLL<>0 then begin
			if _Apci8308wGetDllExportFunc=True then begin
      	Result:=True
			end else Apci8308wDllClose;	// DLL֐擾ɎŝDLLN[Y
		end;
	end;
end;
//===================================================================
//   	DLL۰(۰ގʹװƂ)
//   	
// ߂l  True
//				s False
//===================================================================
function Apci8308wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
		if True=FreeLibrary(hDLL) then begin
			hDLL:=0;
			Result:=True;
		end;
	end;
end;
//===================================================================
//   	DLL,Driver ̃o[W擾
//   	pdwDllVer				DLL o[Wԍi[̈
//        pdwDrvVer				DRV o[Wԍi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8308wGetVersion( var pdwDllVer:DWORD; var pdwDrvVer:DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308GetVersion(pdwDllVer, pdwDrvVer);
end;
//===================================================================
//   	foCXgp錾
//   	pwLogSlot				gpfoCXԍi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8308wCreate( var pwLogSlot:WORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308Create(pwLogSlot);
end;
//===================================================================
//   	foCXJ
//   	wLogSlot				foCX̘_Xbgԍ
// ߂l  True
//				s False
//===================================================================
function Apci8308wClose( wLogSlot:WORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308Close(wLogSlot);
end;
//===================================================================
//   	\[X擾
//   	wLogSlot				foCX̘_Xbgԍ
//				pRes						\[Xi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8308wGetResource( wLogSlot:WORD; pRes:PAPCI8308R ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308GetResource(wLogSlot,pRes);
end;
//===================================================================
//   	arml擾
//   	wLogSlot				foCX̘_Xbgԍ
//				pdwSwitchValue	armli[̈
// ߂l  True
//				s False
//===================================================================
function Apci8308wGetSwitchValue( wLogSlot:WORD; var pdwSwitchValue:DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308GetSwitchValue(wLogSlot,pdwSwitchValue);
end;
//===================================================================
//   	G[擾
//   	wLogSlot				foCX̘_Xbgԍ
// ߂l G[
//===================================================================
function Apci8308wGetLastError( wLogSlot:WORD ):DWORD;
begin
	if hDLL=0 then Result:=APCI8308_ERR_WRAPDLL
	else Result:=pApci8308GetLastError(wLogSlot)
end;
//===================================================================
//   	VAʐMJn
//   	wLogSlot				foCX̘_Xbgԍ
//				wCh							gp`l
//				pMode						샂[hi[Ă̈
// ߂l  True
//				s False
//===================================================================
function Apci8308wSioStart( wLogSlot:WORD; wCh:WORD; pMode:PSIOMODE ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308SioStart(wLogSlot,wCh,pMode);
end;
//===================================================================
//   	ʐMXe[^X擾
//   	wLogSlot				foCX̘_Xbgԍ
//				wCh							gp`l
//				pStatus					Xe[^Xi[̈
// ߂l  True
//				s False
//===================================================================
function Apci8308wSioGetStatus( wLogSlot:WORD; wCh:WORD; pStatus:PSIOSTATUS ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308SioGetStatus(wLogSlot,wCh,pStatus);
end;
//===================================================================
//   	f[^M
//   	wLogSlot				foCX̘_Xbgԍ
//				wCh							gp`l
//				pbData					Mf[^ۑ̈
//				dwDataSize			Mf[^
// ߂l  True
//				s False
//===================================================================
function Apci8308wSioRead( wLogSlot:WORD; wCh:WORD; var pbData:array of BYTE; dwDataSize:DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308SioRead(wLogSlot,wCh,PChar(@pbData),dwDataSize);
end;
//===================================================================
//   	f[^M
//   	wLogSlot				foCX̘_Xbgԍ
//				wCh							gp`l
//				pbData					Mf[^̈
//				dwDataSize			Mf[^
// ߂l  True
//				s False
//===================================================================
function Apci8308wSioWrite( wLogSlot:WORD; wCh:WORD; var pbData:array of BYTE; dwDataSize:DWORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308SioWrite(wLogSlot,wCh,PChar(@pbData),dwDataSize);
end;
//===================================================================
//   	obt@̃Zbg
//   	wLogSlot				foCX̘_Xbgԍ
//				wCh							gp`l
// ߂l  True
//				s False
//===================================================================
function Apci8308wSioReset( wLogSlot:WORD; wCh:WORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308SioReset(wLogSlot,wCh);
end;
//===================================================================
//   	VAʐM~
//   	wLogSlot				foCX̘_Xbgԍ
//				wCh							gp`l
// ߂l  True
//				s False
//===================================================================
function Apci8308wSioStop( wLogSlot:WORD; wCh:WORD ):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8308SioStop(wLogSlot,wCh);
end;
//-------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//-------------------------------------------------------------------
function _Apci8308wGetDllExportFunc: Boolean;
begin
	Result:=False;

	pApci8308GetVersion			:=GetProcAddress(hDLL, 'Apci8308GetVersion');
	pApci8308Create					:=GetProcAddress(hDLL, 'Apci8308Create');
	pApci8308Close					:=GetProcAddress(hDLL, 'Apci8308Close');
	pApci8308GetResource		:=GetProcAddress(hDLL, 'Apci8308GetResource');
	pApci8308GetSwitchValue	:=GetProcAddress(hDLL, 'Apci8308GetSwitchValue');
	pApci8308GetLastError		:=GetProcAddress(hDLL, 'Apci8308GetLastError');
	pApci8308SioStart				:=GetProcAddress(hDLL, 'Apci8308SioStart');
	pApci8308SioGetStatus		:=GetProcAddress(hDLL, 'Apci8308SioGetStatus');
	pApci8308SioRead				:=GetProcAddress(hDLL, 'Apci8308SioRead');
	pApci8308SioWrite				:=GetProcAddress(hDLL, 'Apci8308SioWrite');
	pApci8308SioReset				:=GetProcAddress(hDLL, 'Apci8308SioReset');
	pApci8308SioStop				:=GetProcAddress(hDLL, 'Apci8308SioStop');

	if @pApci8308GetVersion			=nil then Exit;
	if @pApci8308Create					=nil then Exit;
	if @pApci8308Close					=nil then Exit;
	if @pApci8308GetResource		=nil then Exit;
	if @pApci8308GetSwitchValue	=nil then Exit;
	if @pApci8308GetLastError		=nil then Exit;
	if @pApci8308SioStart				=nil then Exit;
	if @pApci8308SioGetStatus		=nil then Exit;
	if @pApci8308SioRead				=nil then Exit;
	if @pApci8308SioWrite				=nil then Exit;
	if @pApci8308SioReset				=nil then Exit;
	if @pApci8308SioStop				=nil then Exit;

	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.





